#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade
import shutil
import time
import os
import sys
from subprocess import call

class VBlast:

	def __init__(self):
	    self.gladefile = "VBlast2.glade" 
	    self.glade = gtk.Builder()
	    self.glade.add_from_file(self.gladefile)
	    self.glade.connect_signals(self)
	    self.glade.get_object("Voice Blast").show_all()
	    self.glade.get_object("filechooserbutton1").set_current_folder("./")
	    self.glade.get_object("filechooserbutton2").set_current_folder("./")
	    	
	def change_label(self):
		audio_src = self.glade.get_object("filechooserbutton1").get_filename()
		phone_src = self.glade.get_object("filechooserbutton2").get_filename()
		
		if phone_src == None:
			self.glade.get_object("label4").set_text("Please select the Phonenumber File")
			return

		MAX_RETRIES = "1" # Hence total no of attempts is MAX_RETRIES + 1(initial)
		RETRY_TIME = "" # in seconds
		NEW_LINE = "\n"
		AUDIO_FILE_DURATION = self.glade.get_object("spinbutton1").get_value_as_int()
		#print AUDIO_FILE_DURATION
		#sys.exit()
		BUFFER_TIME_TO_CALL = 45

		TIME_TO_SLEEP = AUDIO_FILE_DURATION + BUFFER_TIME_TO_CALL

		# Opens the file cotaining the list of phone numbers
		f = open(phone_src,"r")

		# Reads the phone numbers which are line separated
		lines = f.readlines()

		NO_OF_PHONE_NUMBERS = len(lines)
		RETRY_TIME_NUM = NO_OF_PHONE_NUMBERS * TIME_TO_SLEEP
		RETRY_TIME = str(RETRY_TIME_NUM)
		
		#strips the trailing \n from each phone number
		lines = [line.rstrip("\n") for line in lines]
		f.close()
		DISPLAY_TIME_SECS = (RETRY_TIME_NUM * (int(MAX_RETRIES) + 1))
		DISPLAY_TIME_HRS = str(DISPLAY_TIME_SECS/3600)
		DISPLAY_TIME_MINS = str((DISPLAY_TIME_SECS%3600)/60)

		self.glade.get_object("label4").set_text("The approx time taken is:\n"+DISPLAY_TIME_HRS+" hrs and "+DISPLAY_TIME_MINS+" mins 			\nPlease do not close this window until then!")


	def on_button1_clicked(self, widget):
	
		audio_src = self.glade.get_object("filechooserbutton1").get_filename()
		phone_src = self.glade.get_object("filechooserbutton2").get_filename()

		if audio_src == None:
			self.glade.get_object("label4").set_text("Please select the Audio File!!!!")
			return

		if phone_src == None:
			self.glade.get_object("label4").set_text("Please select the Phonenumber File!!!")
			return

		call(["sudo","cp",str(audio_src),"/var/lib/asterisk/sounds/"])
		
		src = "./" #The current directory
		dest = "/var/spool/asterisk/outgoing/" # directory where call files will be moved to

		MAX_RETRIES = "1" # Hence total no of attempts is MAX_RETRIES + 1(initial)
		RETRY_TIME = "" # in seconds
		DATA_FILE = os.path.basename(os.path.splitext(str(audio_src))[0])
		NEW_LINE = "\n"
		AUDIO_FILE_DURATION = self.glade.get_object("spinbutton1").get_value_as_int()
		BUFFER_TIME_TO_CALL = 30

		TIME_TO_SLEEP = AUDIO_FILE_DURATION + BUFFER_TIME_TO_CALL

		# Opens the file cotaining the list of phone numbers
		f = open(phone_src,"r")

		# Reads the phone numbers which are line separated
		lines = f.readlines()

		NO_OF_PHONE_NUMBERS = len(lines)
		RETRY_TIME_NUM = NO_OF_PHONE_NUMBERS * TIME_TO_SLEEP
		RETRY_TIME = str(RETRY_TIME_NUM)

		PREFIX = "Channel: Dongle/dongle0/+91"
		SUFFIX = "MaxRetries: "+ MAX_RETRIES+"\nRetryTime: "+RETRY_TIME+"\nApplication: Playback\nData: "+ DATA_FILE

		#strips the trailing \n from each phone number
		lines = [line.rstrip("\n") for line in lines]
		f.close()
		
		# For each of the phone number item create a call file and move it to the spools directory
		# Asterisk will automatically pick the call files and queue them for outgoing
		for item in lines:
			filename = item+".call"
			target = open(filename, "a")
			finalTextToWrite = PREFIX + item + NEW_LINE + SUFFIX
			target.write(finalTextToWrite)
			target.close()
			shutil.move(src + filename, dest)
			time.sleep(TIME_TO_SLEEP)
		
		self.glade.get_object("button1").set_sensitive(True)
		self.glade.get_object("button2").set_sensitive(True)
		

	def on_button2_clicked(self, widget):
		sys.exit()

	def gtk_main_quit(self, widget):
		sys.exit()

	def on_filechooserbutton2_file_set(self, widget):
		self.change_label()
		
	def on_spinbutton1_value_changed(self, widget):
		self.change_label()
				
		

if __name__ == "__main__":
	euid = os.geteuid()
	if euid != 0:
		print "Script not started as root. Running sudo.."
		args = ['sudo', sys.executable] + sys.argv + [os.environ]
		# the next line replaces the currently-running process with the sudo
		os.execlpe('sudo', *args)	
	try:
	    a = VBlast()
	    gtk.main()
	except KeyboardInterrupt:
	    pass
